program exercise22
  implicit none

  ! 二分法でf(x)=0の解を求めるプログラム
  
  real*8 :: x_l, x_r, f_l, f_r, x_mean, f_mean, eps = 1.0d-14
  integer :: iter

  ! x_lとx_rの初期値
  x_l = 0.0d0
  x_r = 10.0d0

  ! 符号をチェックするためf(x_l)とf(x_r)を計算
  f_l = f(x_l)
  f_r = f(x_r)

  ! 二分法ではこれらの符号が違う(積の符号が負)
  if( f_l*f_r .gt. 0.0d0) then
     write(0,*) "choose other values for x_l and x_r"
  end if

  ! 反復の回数カウンタ
  iter = 1

  ! 反復のループ
  do 

     ! 中点の値
     x_mean=(x_l+x_r)/2.0d0
     ! 中点でのf(x)の値
     f_mean=f(x_mean)
     
     if( f_mean*f_l .gt. 0.0d0) then
        ! 中点でのf(x)の符号がf(x_l)と同じであれば
        ! x_lを中点で置き換える。f_lも中点での値に置き換える
        x_l = x_mean
        f_l = f_mean
     else
        ! そうでない場合、中点でのf(x)の符号はf(x_r)と同じなので
        ! x_rを中点で置き換える。f_rも中点での値に置き換える
        x_r = x_mean
        f_r = f_mean
     end if

     ! 反復の途中経過を出力
     print *, "iter = ", iter, "x_mean = ", x_mean, "f_mean = ", f_mean

     ! x_rとx_lが十分に近くなったらdoループから抜ける。
     ! あるいはf_meanが十分ゼロに近づいたらでもよい。
     if( abs(x_r - x_l) .lt. eps) exit

     ! 反復カウンタを１増やす
     iter = iter + 1

     ! 1000回反復しても終了しない場合はなにかおかしいため強制的に終了する
     if( iter .eq. 1000) stop "iteration did not converge."
     
  end do
  
contains

  ! f(x)の値を返す関数副プログラム
  function f(x)
    real*8, intent(in) :: x
    real*8 :: f
    f = sin(x/4.0d0) - cos(x/4.0d0)

    return

  end function f
  
end program exercise22
