program exercise23
  implicit none

  ! 割線法でf(x)=0の解を求めるプログラム
  
  real*8 :: x_1, x_2, f_1, f_2, x_sec, f_sec, eps=1.0d-14
  integer :: iter

  ! x_1とx_2の初期値
  x_1 = 0.0d0
  x_2 = 10.0d0

  ! f(x_l)とf(x_r)を計算
  f_1 = f(x_1)
  f_2 = f(x_2)

  ! 反復の回数カウンタ
  iter = 1

  ! 反復のループ
  do 

     ! 割線の次の点を計算
     x_sec = x_2 - (x_2 - x_1)/(f_2 -f_1)*f_2
     f_sec = f(x_sec)

     ! インデックスをずらす
     x_1 = x_2
     f_1 = f_2

     x_2 = x_sec
     f_2 = f_sec

     ! 反復の途中経過を出力
     print *, "iter = ", iter, "x_sec = ", x_sec, "f_sec = ", f_sec

     ! f_secが十分ゼロに近づいたらdoループから抜ける
     if( abs(f_sec) .lt. eps) exit

     ! 反復カウンタを１増やす
     iter = iter + 1

     ! もし問題が起きた場合1000回で反復を強制的に終了する
     if( iter .eq. 1000) stop "iteration did not converge"
     
  end do

  
contains

  ! f(x)の値を返す関数副プログラム
  function f(x)
    real*8, intent(in) :: x
    real*8 :: f
    f = sin(x/4.0d0) - cos(x/4.0d0)

    return

  end function f
  

end program exercise23
